/****************************************************************/
/*								*/
/*	XChess V2.7 Adapter: Curses				*/
/*								*/
/*	(c) 1991 by Marc Laukien				*/
/*								*/
/*	Programmteil:	Spieler-ID liefern			*/
/*								*/
/****************************************************************/

#include <curses.h>
#include <pwd.h>
#include "ad.h"

/****************************************************************/
/*	String mit ID zu Username liefern			*/
/****************************************************************/
/*	Return:	String mit ID					*/
/****************************************************************/

char	*ad_id(name)

char	*name;
{
	static	char	id[STRLEN];
	struct	passwd	*pwd;

	if(name[0]=='~' || strcmp(name,comp)==0)	/* Rechner ?	*/
		return("~");

	pwd=getpwnam(name);		/* Passwordeintrag holen	*/

	if(pwd!=(struct passwd *)0)	/* Kein 0-Pointer ?		*/
		sprintf(id,"%d",pwd->pw_uid);
	else
		strcpy(id,"?");

	return(id);
}

/****************************************************************/
/*	String mit Username zu ID liefern			*/
/****************************************************************/
/*	Return:	String mit Username				*/
/****************************************************************/

char	*ad_revid(id)

char	*id;
{
	static	char	name[STRLEN];
	struct	passwd	*pwd;

	if(id[0]=='~')			/* Rechner ?			*/
		return(comp);

	pwd=getpwuid(atoi(id));		/* Passwordeintrag holen	*/

	if(pwd!=(struct passwd *)0)	/* Kein 0-Pointer ?		*/
		sprintf(name,"%s",pwd->pw_name);
	else
		sprintf(name,"%s",id);

	return(name);
}


